﻿using Microsoft.Office.Interop.Outlook;
using System;
using System.Text;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 커스텀 애드인
    /// </summary>
    public partial class CustomAddIn
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 커스텀 애드인 시작시 처리하기 - CustomAddIn_Startup(sender, e)

        /// <summary>
        /// 커스텀 애드인 시작시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void CustomAddIn_Startup(object sender, EventArgs e)
        {
            SearchFolder();
        }

        #endregion
        #region 커스텀 애드인 셧다운시 처리하기 - CustomAddIn_Shutdown(sender, e)

        /// <summary>
        /// 커스텀 애드인 셧다운시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void CustomAddIn_Shutdown(object sender, EventArgs e)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region VSTO에서 생성한 코드

        /// <summary>
        /// 디자이너 지원에 필요한 메서드입니다. 
        /// 이 메서드의 내용을 코드 편집기로 수정하지 마세요.
        /// </summary>
        private void InternalStartup()
        {
            this.Startup  += new System.EventHandler(CustomAddIn_Startup );
            this.Shutdown += new System.EventHandler(CustomAddIn_Shutdown);
        }

        #endregion

        #region 폴더 검색하기 - SearchFolder()

        /// <summary>
        /// 폴더 검색하기
        /// </summary>
        private void SearchFolder()
        {
            Folder   folder       = (Folder)Application.ActiveExplorer().Session.GetDefaultFolder(OlDefaultFolders.olFolderInbox);
            Items    foloderItems = folder.Items;
            object   folderItem   = null;
            MailItem mailItem     = null;

            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.AppendLine("The following e-mail messages were found : ");

            folderItem = foloderItems.Find("[Subject] > 's' And [Subject] <'u'");

            while(folderItem != null)
            {
                mailItem = folderItem as MailItem;

                if(mailItem != null)
                {
                    stringBuilder.AppendLine(mailItem.Subject);
                }

                folderItem = foloderItems.FindNext();
            }

            MessageBox.Show(stringBuilder.ToString());
        }

        #endregion
    }
}